/*******************************************************************************
 * Copyright (c) 2015-2017 ONERA and IRT AESE (IRT Saint Exupéry).
 * Ce logiciel est la propriété de l’ONERA (the French Aerospace Lab) et de
 * l'IRT AESE (IRT Saint Exupéry).
 * Tous droits réservés.
 *
 * Ce programme et les éléments qui l'accompagnent sont mis à disposition
 * aux conditions définies par le contrat de licence logiciel CeCILL-C soumise
 * au droit français et respectant les principes de diffusion des logiciels libres.
 * Vous pouvez utiliser, modifier et/ou redistribuer ce programme
 * sous les conditions de la licence CeCILL-C (http://www.cecill.info).

 * This software is property of ONERA (the French Aerospace Lab) and of
 * the IRT AESE (IRT Saint Exupéry).
 * All rights reserved.
 *
 * This program and the accompanying materials are made available under
 * the terms of the CeCILL-C license under French law and
 * abiding by the rules of distribution of free software.
 * You can  use, modify and/ or redistribute the software under the terms of
 * the CeCILL-C license (http://www.cecill.info).
 *
 * Contributeurs/contributors:
 *     Guillaume Infantes (ONERA - Centre de Toulouse) - initial API and implementation
 *     Alexandre Albore (IRT Saint-Exupéry) - Altarica/Fiacre translation
 *
 *******************************************************************************/

#ifndef VISITOR_HH
#define VISITOR_HH


namespace epoch {
  namespace altarica {

    class Expression;
    class ExpressionADD;
    class ExpressionAND;
    class ExpressionARITH;
    class ExpressionATOMIC;
    class ExpressionBOOLCONSTANT;
    class ExpressionCARD;
    class ExpressionCONSTARRAY;
    class ExpressionCONSTSTRUCT;
    class ExpressionCASE;
    class ExpressionFUNCTIONCALL;
    class ExpressionIfThenElse;
    class ExpressionLOG;
    class ExpressionMEMBER;
    class ExpressionMINMAX;
    class ExpressionMUL;
    class ExpressionOR;
    class ExpressionPAREN;
    class ExpressionQUANTIFIED;
    class ExpressionUNSIGNEDINT;
    class ExpressionREAL;
    class ExpressionUNARY;
    class ExpressionINTERVAL;


    class Visitor {
    public:
      virtual void visitADD(const ExpressionADD *e) =0;
      virtual void visitAND(const ExpressionAND *e) =0;
      virtual void visitARITH(const ExpressionARITH *e) =0;
      //      virtual void visitATOMIC(const ExpressionATOMIC *e) =0;
      virtual void visitBOOLCONSTANT(const ExpressionBOOLCONSTANT *e) =0;
      virtual void visitCARD(const ExpressionCARD *e) =0;
      virtual void visitCONSTARRAY(const ExpressionCONSTARRAY *e) =0;
      virtual void visitCONSTSTRUCT(const ExpressionCONSTSTRUCT *e) =0;
      virtual void visitCASE(const ExpressionCASE *e) =0;
      virtual void visitFUNCTIONCALL(const ExpressionFUNCTIONCALL *e) =0;
      virtual void visitIfThenElse(const ExpressionIfThenElse *e) =0;
      virtual void visitLOG(const ExpressionLOG *e) =0;
      virtual void visitMEMBER(const ExpressionMEMBER *e) =0;
      virtual void visitMINMAX(const ExpressionMINMAX *e) =0;
      virtual void visitMUL(const ExpressionMUL *e) =0;
      virtual void visitOR(const ExpressionOR *e) =0;
      virtual void visitPAREN(const ExpressionPAREN *e) =0;
      virtual void visitQUANTIFIED(const ExpressionQUANTIFIED *e) =0;
      virtual void visitUNSIGNEDINT(const ExpressionUNSIGNEDINT *e) =0;
      virtual void visitREAL(const ExpressionREAL *e) = 0;
      virtual void visitUNARY(const ExpressionUNARY *e) = 0;
      virtual void visitINTERVAL(const ExpressionINTERVAL *e) = 0;

    };
  }
}

#endif
